/*
       The Travelling Salesman Problem Solver

       Host utility subroutines.
       Runs on host, not Hypercube.
*/	
#include "stdio.h"
#include "config.h"
#include "travel.h"
#include <time.h>
/*
       utime.c	--  timing and editing of time.
*/
static long tstart;			       /* timing start */
#define	SECSPERDAY ((long) 60*60*24)	       /* seconds in a day */
/*
       utnow  --  return seconds since epoch (0000 1JAN1970)
*/
long utnow()  
{
       long now;			       /* seconds since	epoch */
       long time();			       /* library */
       now = time((char	*)0);		       /* get time now */
       return(now);			       /* return seconds since epoch */
}
/*
       uelapsed	 --  compute elapsed time
*/
long uelapsed(start)			/* returns difference */
long start;				       /* start	time */
{      long diff;			       /* difference */
       diff = utnow() -	start;		       /* compute elapsed time */
       if (diff	< 0)			       /* if time went backwards */
       {       
	       while (diff < 0)	diff +=	SECSPERDAY; /* MSDOS bug  -  bad date */
       }
       return(diff);			       /* now positive */
}
/*
       utstart	--  start timing
*/
utstart()
{
       tstart =	utnow();		       /* get time now */
}
/*
       utend  --  end timing and return	difference
*/
long utend()				/* end time */
{
       return(uelapsed(tstart));	       /* return elapsed time */
}
/*
       utedit --  Edit time to string

       Returned	format is NN:NN:NN.

       Language-independent.
*/
char *utedit(secs)
long secs;				       /* seconds to edit */
{      short hh,mm,ss;			       /* hours, minutes, secs */
       static char s[15];		       /* for message */
       hh = secs / 3600;		       /* hours	*/
       secs %= 3600;			       /* remove hours */
       mm = secs / 60;			       /* minutes */
       ss = secs % 60;			       /* seconds */
       s[0] = '\0';                            /* clear string */
       sprintf(s, "%02d:%02d:%02d", hh, mm, ss);
       return(s);			       /* return string	*/
}
/*
       panic  --  print	message	and exit
*/
panic(msg)
char msg[];			       /* message */
{
       fprintf(stderr,"***INTERNAL ERROR: %s ***\n",msg);
       exit(1);			       /* fails	*/
}
/*
       assertfail  --  assertion failure
*/
assertfail(msg)
char msg[];			       /* message */
{
       fprintf(stderr,"***ASSERTION FAILURE: %s ***\n",msg);
       exit(1);			       /* fails	*/
}
