/* dual.c */
void rowdual(int *rownr);
short coldual(int *numeta, int *rownr, int *colnr, short *minit, double *prow, double *drow);

/* lp.c */
int yyparse(void);

/* read.c */
void yyerror(char *string);
void check_decl(char *str);
void add_int_var(char *name);
void init_read(void);
int hashvalue(char* string);
hashelem *gethash(char* variable);
column *getrow(column *p, int row);
bound *create_bound_rec(void);
void null_tmp_store(void);
void store(char* variable, int row, double value);
void store_re_op(void);
void rhs_store(double value);
void var_store(char *var, int row, double value);
int store_bounds(void);
void resize_eta(void);
void readinput(int *cend, double *rh, short *relat, double *lowbo, double *upbo, matrec *mat, nstring *names);

/* tran.c */
void ftran(int start, int end, double *pcol);
void btran(int numc, double *row);

/* main.c */
short is_int(double value);
void allocate_globals(void);
void signal_handler(int sig);

/* solve.c */
void condensecol(int rownr, int numc, double *pcol);
void addetacol(int *numc);
void presolve(void);
void setpivcol(short *lower, int varin, int numeta, double *pcol);
short colprim(int *colnr, int *numeta, short *minit, double *drow);
void minoriteration(int colnr, int rownr, int *numeta);
void rhsmincol(double *theta, int rownr, int varin, int numeta);
void invert(int n, int *numeta, int *numinv);
short rowprim(int *rownr, double *theta, double *pcol);
void iteration(int *numc, int *rownr, int *varin, double *theta, double *up, short *minit, short *low, short *primair, short *smotes, int *iter, int *numinv);
int solvelp(void);
void construct_solution(double *sol);
int solve(double *upbo, double *lowbo);

/* write.c */
void print_solution(FILE *stream, double *sol);
void print_indent(void);
void debug_print_solution(double *sol);
void debug_print_bounds(double *upbo, double *lowbo);
void debug_print(char *format, ...);

