/*
       The Travelling Salesman Problem Solver

       Node utility subroutines.
       Runs on Hypercube.
*/	
#include <stdio.h>		       /* ***TEMP*** */
#include <assert.h>
#include "config.h"
#include "travel.h"
#if HYPERCUBE
/*
       panic  --  print	message	and exit

       ***NEEDS	WORK, CANNOT PRINT HERE***
*/
void panic(msg)
char msg[];		       /* message */
{
       fprintf(stderr,"***INTERNAL ERROR: %s ***\n",msg);
       exit(1);			       /* fails	*/
}
#endif HYPERCUBE
/*
       irandom	--  return random number in range lo..hi

       The constants below meet	the critera of Theorem A,
       sec. 3.2.1.2, Knuth's Seminumerical Algorithms.
       This function may be repeatable but must	behave DIFFERENTLY on
       each node.
*/
int irandom(lo,hi)
short lo,hi;			       /* bounds for output */
{
       static short rand1 = 12345;     /* starting seed	*/
       static short rand2 = 43457;     /* starting seed	*/
       short n;			       /* working number */
       short rand;		       /* random bit pattern */
       rand1 = rand1*(3141*4+1)	+ 31433;    /* next random number */
       rand2 = rand2*(2396*4+1)	+ 23589;    /* next random number */
       rand = rand1 + (rand2>>1);      /* working value	*/
       rand = max(rand,-32767);	       /* avoid	underflow */
       rand = abs(rand);	       /* make nonnegative */
       assert(lo <= hi);	       /* bounds valid */
       n = rand	% (1+hi-lo) + lo;      /* compute random number	*/	     
       assert(n	>= lo);		       /* validate bounds */
       assert(n	<= hi);		       /* validate bounds */
       return(n);		       /* and return it	*/
}
