/*
       The Travelling Salesman Problem Solver

       Path utilities
       Runs on host, not Hypercube.
*/	
#include "stdio.h"
#include "config.h"
#include "travel.h"
extern long distance();		       /* external */
/*
       initpath	 --  initialize	a path structure given a city structure

       An arbitrary path is constructed	by linking the cities in order.
       The city	table must be initialized first.
*/
void initpath(pathp)
struct path *pathp;			       /* path structure OUT */
{
       short i;				       /* for loops */
       short cnt;			       /* number of cities */
       long length = 0;			       /* length of path so far	*/
       cnt = getcnt();			       /* get count of cities */
       for (i=0; i<cnt;	i++)		       /* for indicated	cities */
       {       pathp->plinks[i]	= i;	       /* init to own index */
	       if (i>0)			       /* if not first one */
	       {       
		       length += distance(i-1,i);      /* add inter-city distance */
	       }
       }
       pathp->pathn = cnt;		       /* number of entries */
       pathp->pathl = length;		       /* total	length */
}
