.TH PLAN L "\*(V)" "4BSD"
.SH NAME
plan - run an executable when a specified FIFO is opened
.SH SYNOPSIS
.B plan
[
.BR -f file
]
.B executable
.SH DESCRIPTION
.I plan
takes the name of an executable program and runs it on a FIFO that
is specified on the command line or on a FIFO in the user's home directory
named .plan.  Whenever the FIFO is accessed, the output of the executable
program goes to the FIFO.
.SH OPTIONS
.TP
.B \-f file_name
The \fB\-f flag causes \fIplan\fR to set up the specified \fBfile_name\fR
as a FIFO rather than the default \fB$HOME/.plan\fR.
.PP
Some sample uses of \fIplan\fR would be:
.TP
.B plan /usr/games/fortune &
This will display a randomly selected fortune as the contents of
your .plan file whenever you are fingered.
.TP
.B plan -f ~/.signature ~/bin/gensig &
This will run the program gensig whenever your .signature file is accessed,
allowing you to change your .signature whenever you post.
.TP
.B plan ~/bin/logfinger &
This will run the program logfinger whenever your .plan file is accessed,
and you can log all instances of people fingering you.
.SH AUTHOR
Tony Rems (rembo@unisoft.com)
.PP
Modifications by Geoff Loker (geoff@mdms.moore.com)
.SH BUGS
Your system must support named pipes in order for this to work.
