/*
       The Travelling Salesman Problem Solver

       Definitions	
*/	

#define	TRUE   1
#define	FALSE  0
#define	NONE   -1		       /* invalid value	when needed */
typedef	char boolean;		       /* standard meaning */
#ifndef	abs			       /* if no	stdio.h	*/
#define	abs(x) ((x)<0?-(x):(x))
#define	max(a,b) ((a)>(b)?(a):(b))
#define	min(a,b) ((a)<=(b)?(a):(b))
#endif 
/*
       Information for one city.
*/
struct city {
       short cityx;		       /* X coordinate */
       short cityy;		       /* Y coordinate */
       };
/*
       Information for all cities
*/
struct cities {
       short cccount;		       /* number of cities */
       struct city ccc[NCITIES];       /* city information */
       };
/*
       plink  --  one doubly-linked path item  

       In headers, these are ordered; the first	points to the head of
       the list	and the	last points to the tail.  But in the plinks
       array, either link may be used for either direction, and	the
       OTHERWAY	macro must be used to move through the list.  This
       allows the reversal of subpaths without altering	links within
       the subpath.
*/
struct plink {
       short plfirst;		       /* previous city	number */
       short pllast;		       /* next city number */
       };
/*
       path  --	 describes a complete path through all cities

       This is just a table of city numbers.  More complicated
       data structures are possible but	it appears that	since	
       more time is spent looking for places to	improve	the
       path than actually rearranging it, they are not justified.
*/
struct path {
       short pathn;		       /* number of cities */
       long pathl;		       /* length of current path */
       short plinks[NCITIES];	       /* array	of city	links */
       };


